/*
Copyright (c) 2007 Gerard Marull Paretas.
*/

#define F_CPU 8000000

#define LOOP_CYCLES 8 //8 -O3 				//Number of cycles that the loop "onewire_delay" takes (in ASM)
#define us(num) (num/(LOOP_CYCLES*(1/(F_CPU/1000000.0))))

#define THERM_PORT		 PORTD
#define THERM_DDR		 DDRD
#define THERM_PIN		 PIND
#define THERM_DQ		 0

// Macros
#define THERM_INPUT_MODE()		(THERM_DDR  &= ~(unsigned char)_BV(THERM_DQ))
#define THERM_OUTPUT_MODE()		(THERM_DDR  |= (unsigned char)_BV(THERM_DQ))
#define THERM_LOW()				(THERM_PORT &= ~(unsigned char)_BV(THERM_DQ))
#define THERM_HIGH()			(THERM_PORT |= (unsigned char)_BV(THERM_DQ))

// List of these commands translated into C defines:
#define THERM_CMD_CONVERTTEMP	0x44
#define THERM_CMD_RSCRATCHPAD	0xbe
#define THERM_CMD_WSCRATCHPAD	0x4e
#define THERM_CMD_CPYSCRATCHPAD	0x48
#define THERM_CMD_RECEEPROM		0xb8
#define THERM_CMD_RPWRSUPPLY	0xb4
#define THERM_CMD_SEARCHROM		0xf0
#define THERM_CMD_READROM		0x33
#define THERM_CMD_MATCHROM		0x55
#define THERM_CMD_SKIPROM		0xcc
#define THERM_CMD_ALARMSEARCH	0xec

#define	THERM_INVALID			0x00FF		// DS18S20 can't return this temperature, so we will call it "invalid"

void onewire_delay(uint16_t);

uint8_t onewire_reset();

void onewire_wbit(uint8_t);
void onewire_wbyte(uint8_t);

uint8_t onewire_rbit(void);
uint8_t onewire_rbyte(void);

int8_t therm_read_temperature();
